/*
Module : GPSCom2.h
Purpose: Main App Module class for GPSCom2
Created: PJN / 27-04-2010

Copyright (c) 2010 - 2023 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code. 

*/


//////////////////// Macros / Defines /////////////////////////////////////////

#pragma once


//////////////////// Includes /////////////////////////////////////////////////


#ifndef __ATLCOLL_H__
#pragma message("To avoid this message, please put atlcoll.h in your pre compiled header (normally stdafx.h)")
#include <atlcoll.h>
#endif //#ifndef __ATLCOLL_H__
#include "GPSCom2_i.h"
#include "GPSConnection.h"


//////////////////// Classes //////////////////////////////////////////////////

class CGPSCom2Module : public ATL::CAtlExeModuleT< CGPSCom2Module >
{
public:
#pragma warning(suppress: 26440)
  DECLARE_LIBID(LIBID_GPSCom2Lib) //NOLINT(modernize-use-noexcept)
#pragma warning(suppress: 26440 26477 26485 26486)
  DECLARE_REGISTRY_APPID_RESOURCEID(IDR_GPSCOM2, "{61442B0D-9758-43AD-88A5-ADDCFB82179E}") //NOLINT(modernize-avoid-c-arrays, modernize-use-noexcept)

//Member variables
  ATL::CAtlArray<ATL::CComObject<CGPSConnection>*> m_Connections;
  ATL::CComAutoCriticalSection m_csConnections;
};

extern CGPSCom2Module _AtlModule;
