/*
Module : GPSConnections.h
Purpose: Connections class for GPSCom2
Created: PJN / 27-04-2010

Copyright (c) 2010 - 2023 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code. 

*/


//////////////////// Macros / Defines /////////////////////////////////////////

#pragma once

#ifndef __GPSCONNECTIONS_H_
#define __GPSCONNECTIONS_H_


//////////////////// Includes /////////////////////////////////////////////////

#include "GPSCom2_i.h"


//////////////////// Classes //////////////////////////////////////////////////

class ATL_NO_VTABLE CGPSConnections :
  public ATL::CComObjectRootEx<ATL::CComSingleThreadModel>,
  public ATL::CComCoClass<CGPSConnections, &CLSID_GPSConnections>,
  public ATL::ISupportErrorInfoImpl<&IID_IGPSConnections>,
  public ATL::IDispatchImpl<IGPSConnections, &__uuidof(IGPSConnections)>
{
public:
#pragma warning(suppress: 26440)
  DECLARE_REGISTRY_RESOURCEID(IDR_GPSCONNECTIONS)

#pragma warning(suppress: 26429 26440 26447 26477 26481)
  BEGIN_COM_MAP(CGPSConnections) //NOLINT(modernize-avoid-c-arrays, modernize-use-noexcept)
    COM_INTERFACE_ENTRY(IGPSConnections)
    COM_INTERFACE_ENTRY(IDispatch)
    COM_INTERFACE_ENTRY(ISupportErrorInfo)
#pragma warning(suppress: 26477 26485)
  END_COM_MAP()

#pragma warning(suppress: 26434)
  DECLARE_PROTECT_FINAL_CONSTRUCT()

//IGPSConnections
  STDMETHOD(get_Count)(long* pVal);
  STDMETHOD(Item)(long nIndex, IGPSConnection** ppConnection);
  STDMETHOD(get__NewEnum)(IUnknown** ppVal);
};

#pragma warning(suppress: 26477)
OBJECT_ENTRY_AUTO(__uuidof(GPSConnections), CGPSConnections)


#endif //#ifndef __GPSCONNECTIONS_H_
