/*
Module : GPSPort.h
Purpose: Port class for GPSCom2
Created: PJN / 27-04-2010

Copyright (c) 2010 - 2023 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code.

*/


//////////////////// Macros / Defines /////////////////////////////////////////

#pragma once

#ifndef __GPSPORT_H_
#define __GPSPORT_H_



//////////////////// Includes /////////////////////////////////////////////////

#include "GPSCom2_i.h"


//////////////////// Classes //////////////////////////////////////////////////

class ATL_NO_VTABLE CGPSPort :
  public ATL::CComObjectRootEx<ATL::CComSingleThreadModel>,
  public ATL::CComCoClass<CGPSPort, &CLSID_GPSPort>,
  public ATL::ISupportErrorInfoImpl<&IID_IGPSPort>,
  public ATL::IDispatchImpl<IGPSPort, &IID_IGPSPort, &LIBID_GPSCom2Lib>
{
public:
#pragma warning(suppress: 26440)
  DECLARE_REGISTRY_RESOURCEID(IDR_GPSPORT)

#pragma warning(suppress: 26434)
  DECLARE_PROTECT_FINAL_CONSTRUCT()

#pragma warning(suppress: 26429 26440 26447 26477 26481)
  BEGIN_COM_MAP(CGPSPort) //NOLINT(modernize-avoid-c-arrays, modernize-use-noexcept)
    COM_INTERFACE_ENTRY(IGPSPort)
    COM_INTERFACE_ENTRY(IDispatch)
    COM_INTERFACE_ENTRY(ISupportErrorInfo)
#pragma warning(suppress: 26477 26485)
  END_COM_MAP()

//IGPSPort
  STDMETHOD(CreateConnection)(long Port, long BaudRate, GPS_PARITY parity, long DataBits, GPS_STOP_BITS StopBits, BSTR InitString, IGPSConnection** ppGPSConnection);
  STDMETHOD(CreateConnection2)(long Port, BSTR InitString, IGPSConnection** ppGPSConnection);
};

#pragma warning(suppress: 26477)
OBJECT_ENTRY_AUTO(__uuidof(GPSPort), CGPSPort)


#endif //#ifndef __GPSPORT_H_
